const childProcess  = require('child_process');

'use strict';

var program = require('commander');
var pkg = require('./package.json');

program.version(pkg.version, '-v, --version')
        .option('-h, --help ', 'Help');

function spawnCompiler() {
  console.log('VueJS compiler in progress...');
  var compiler = childProcess.exec('npm run compiler',{cwd: __dirname}, (err, stdout, stderr) => {
    console.log(stdout);
    console.log(stderr);
  });
}

function installPackages(dir) {
  childProcess.exec('cd ' + dir + ' && npm install react-vue react-vue-helper --save',{cwd: __dirname}, (err, stdout, stderr) => {
    console.log(stdout);
    console.log(stderr);
  });
}

program.command('init <project_name>')
        .action(function(project_name) {
          console.log(project_name);
          var init = childProcess.spawn('react-native', ['init', project_name]);
          init.stdout.pipe(process.stdout);
          init.stderr.pipe(process.stderr);
          init.on('exit', () => {
            installPackages(project_name);
          });
        });

program.command('run-android')
        .action(function() {
          var runAndroid = childProcess.spawn('react-native',['run-android']);
          runAndroid.stdout.pipe(process.stdout);
          runAndroid.stderr.pipe(process.stderr);
          runAndroid.on('exit', () => {
              spawnCompiler();
          });
        });

program.command('run-ios')
        .action(function() {
          var runIos = childProcess.spawn('react-native', ['run-ios']);
          runIos.stdout.pipe(process.stdout);
          runIos.stderr.pipe(process.stderr);
          runIos.on('exit', () => {
            spawnCompiler();
          });
        });

program.parse(process.argv);

module.exports = program;
